VERSION 5.00
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.3#0"; "comctl32.ocx"
Begin VB.Form frmMMSync 
   Appearance      =   0  'Flat
   BackColor       =   &H80000005&
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Outlook Plug-in"
   ClientHeight    =   4605
   ClientLeft      =   150
   ClientTop       =   840
   ClientWidth     =   3510
   FillColor       =   &H8000000B&
   FillStyle       =   0  'Solid
   ForeColor       =   &H80000005&
   Icon            =   "frmMMSync.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   4605
   ScaleWidth      =   3510
   StartUpPosition =   3  'Windows Default
   Visible         =   0   'False
   Begin ComctlLib.StatusBar StatusBar1 
      Align           =   2  'Align Bottom
      Height          =   375
      Left            =   0
      TabIndex        =   1
      Top             =   4230
      Width           =   3510
      _ExtentX        =   6191
      _ExtentY        =   661
      Style           =   1
      SimpleText      =   ""
      _Version        =   327682
      BeginProperty Panels {0713E89E-850A-101B-AFC0-4210102A8DA7} 
         NumPanels       =   1
         BeginProperty Panel1 {0713E89F-850A-101B-AFC0-4210102A8DA7} 
            Key             =   ""
            Object.Tag             =   ""
         EndProperty
      EndProperty
   End
   Begin VB.CommandButton exitButton 
      BackColor       =   &H00FFFFFF&
      Caption         =   "Synchronize"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   372
      Left            =   840
      TabIndex        =   0
      Top             =   3480
      Width           =   1692
   End
   Begin VB.Image Image4 
      BorderStyle     =   1  'Fixed Single
      Height          =   4452
      Left            =   0
      Top             =   0
      Width           =   4092
   End
   Begin VB.Image logoSync 
      Appearance      =   0  'Flat
      Height          =   1155
      Left            =   1080
      Picture         =   "frmMMSync.frx":058A
      Top             =   2160
      Width           =   1380
   End
   Begin VB.Image logoFunambol 
      Height          =   1770
      Left            =   720
      Picture         =   "frmMMSync.frx":58D0
      Top             =   240
      Width           =   2190
   End
   Begin VB.Menu fileControl 
      Caption         =   "File"
      Index           =   1
      NegotiatePosition=   1  'Left
      Begin VB.Menu syncControl 
         Caption         =   "Synchronize"
         Index           =   1
      End
      Begin VB.Menu slowSyncControl 
         Caption         =   "Recover (slow sync)..."
         Index           =   1
      End
      Begin VB.Menu exitControl 
         Caption         =   "Exit"
         Index           =   1
      End
   End
   Begin VB.Menu editControl 
      Caption         =   "Edit"
      Index           =   2
      Begin VB.Menu syncSettingsControl 
         Caption         =   "Communication Settings..."
         Index           =   1
      End
      Begin VB.Menu syncSourcesControl 
         Caption         =   "Synchronization Settings..."
         Index           =   1
      End
      Begin VB.Menu syncSchedulerSettings 
         Caption         =   "Scheduler Settings..."
         Index           =   1
      End
   End
   Begin VB.Menu helpControl 
      Caption         =   "Help"
      Index           =   1
      Begin VB.Menu logControl 
         Caption         =   "View logs"
      End
      Begin VB.Menu aboutControl 
         Caption         =   "About"
      End
   End
End
Attribute VB_Name = "frmMMSync"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'
'Copyright (C) 2003-2006 Funambol
'
'This program is free software; you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation; either version 2 of the License, or
'(at your option) any later version.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'
'****************************************************************
'*Form:    frmMMSync.frm                                        *
'*Author:  Marco Magistrali - Funambol                          *
'****************************************************************


Option Explicit
Dim keyValue As Long
Public isBlocking As Boolean

' Backup sync mode in case of slow-sync
Dim syncCalendarsModeBackup As String
Dim syncContactsModeBackup As String
Dim syncTasksModeBackup As String
Dim syncNotesModeBackup As String


Private Sub Form_Initialize()
mdMMVariables.InitCommonControls
End Sub

Private Sub aboutControl_Click()
frmMMAbout.Show 1
End Sub

Private Sub exitButton_Click()
synchronize
End Sub

Private Sub exitControl_Click(Index As Integer)
mdUnload.closeProgram

End Sub


Public Sub Form_Load()
    'During the Form Load it reads all the informations stored in the files
    'regarding the selected Folders and Item Properties to sync,
    'and store them in appropriate arrays.

On Error GoTo Form_Load_Err

Dim path As String
path = mdMMVariables.AppPath()
ChDir (path)
ChDrive (mdMMVariables.AppDrive)
mdMMShiftBit.Init


'Initialization

StatusBar1.SimpleText = ""
logoSync.Picture = LoadPicture(App.path & "\" & DIR_IMAGES & "\" & mdMMVariables.ARROWS_BMP)
logoFunambol.Picture = LoadPicture(App.path & "\" & DIR_IMAGES & "\" & mdMMVariables.LOGO_BMP)

'
' We now center window controls
'
logoSync.Left = (frmMMSync.Width - logoSync.Width) / 2
logoFunambol.Left = (frmMMSync.Width - logoFunambol.Width) / 2
exitButton.Left = (frmMMSync.Width - exitButton.Width) / 2
exitButton.Caption = mdMMVariables.EXIT_BUTTON

ReDim mdVariables.itemProperties(257)

'read from item_for_properties.db all the item properties available for user
mdLoad.loadListForProperties

'Center the form in the screen
Me.Move (Screen.Width - Me.Width) / 2, (Screen.Height - Me.Height) / 2

Form_Load_Exit:
    Exit Sub

Form_Load_Err:

    Dim actionToDo As Integer
    
    actionToDo = mdErrors.fixErrors(Err.number)
    Select Case actionToDo
    Case 0
        GoTo Form_Load_Exit
    Case 1
        Resume
    Case 2
        Resume Next
    End Select

End Sub

Function outlookSession() As Outlook.nameSpace
    'create a reference and logon to the default MAPI session


Dim objNamespace As Outlook.nameSpace

On Error GoTo outlookSession_Err

Set mdMMVariables.objOutlook = CreateObject("Outlook.Application")
Set objNamespace = objOutlook.GetNamespace("MAPI")

' Log on, creating a new MAPI session, using the profile and password
Call objNamespace.Logon(, , True)
Set outlookSession = objNamespace
 
outlookSession_Exit:
    Exit Function

outlookSession_Err:
    printLog "Error creating Outlook reference.", ERROR_LEVEL
    mdUnload.closeProgram
    GoTo outlookSession_Exit
    
End Function

'Logoff Outlook and clean up shared objects
Private Sub exitOutlook()

On Error GoTo exitOutlook_Err

    mdVariables.nameSpace.Logoff
    
    Dim Utils As Redemption.MAPIUtils
    Set Utils = CreateObject("Redemption.MAPIUtils")
    Utils.Cleanup
    
    printLog "Logged off from Outlook", INFO_LEVEL
    Exit Sub

exitOutlook_Err:

    printLog "Unable to Logoff from Outlook", ERROR_LEVEL
    Exit Sub

End Sub



Private Sub loadOutlook()

printDebugMessage "Enter loadOutlook method"

On Error GoTo loadOutlook_Err
Set mdVariables.nameSpace = Outlook.Application.GetNamespace("MAPI")

'Logon as default user, prompt (if required) for profile dialog
mdVariables.nameSpace.Logon , , True, False

'Dim objMySession As MAPI.Session
'Dim MyTimeZone As Long
'Set objMySession = CreateObject("MAPI.Session")
'Set objMySession = New MAPI.Session
'objMySession.Logon , , False, False
'MyTimeZone = objMySession.GetOption("TimeZone")
'objMySession.Logoff
'Set objMySession = Nothing


'read the existent folders and subfolders of the 4 types (Calendar, Contacts, Mail, Tasks)
'for the selected profile and save their EntryID and Name in the arrays of relative type

printDebugMessage "Redim calendar, contacts, tasks, notes Properties array"
'prepare the 4 arrays for the list of Item Properties to sync
'if they remain with 1 position, it means that no properties are selected
ReDim mdVariables.calendarProperties(0)
ReDim mdVariables.contactsProperties(0)
ReDim mdVariables.mailProperties(0)
ReDim mdVariables.tasksProperties(0)
ReDim mdVariables.notesProperties(0)

'test if the file with the selected item properties exists

If mdFileSystem.doesFileExist(mdVariables.NAME_PROPERTIES_FILE) Then
    printDebugMessage mdVariables.NAME_PROPERTIES_FILE + " does exists. Read readPreferencesFromFile"
    logToDebug "Item Properties Preferences YES"
    mdVariables.propExists = True
    mdFileSystem.readPreferencesFromFile mdVariables.NAME_PROPERTIES_FILE
Else
    printDebugMessage mdVariables.NAME_PROPERTIES_FILE + " does NOT exists. Read loadDefaultProperties"
    mdVariables.propExists = False
    logToDebug "File " & mdVariables.NAME_PROPERTIES_FILE & " doesn't exist." & Chr(13) & _
    "The default preferences for item properties will be loaded."
    mdFileSystem.loadDefaultProperties
End If

printDebugMessage "Exit loadOutlook method"
Exit Sub

loadOutlook_Err:
    printLog "Error loading Outlook application.", ERROR_LEVEL
    MsgBox ("Error loading Outlook application.")
    mdUnload.closeProgram
    
End Sub


Public Sub loadFoldersProperties()
printDebugMessage "Enter loadFoldersProperties method"
mdVariables.deletedFolders() = mdVariables.dummyInitializingStringArray()
mdVariables.createdListMM() = mdVariables.dummyInitializingVariantArray()
mdVariables.modifiedListMM() = mdVariables.dummyInitializingVariantArray()
mdVariables.deletedListMM() = mdVariables.dummyInitializingVariantArray()

'test if the file with the selected folders exists
If mdFileSystem.doesFileExist(mdVariables.NAME_PREFERENCES_FILE) Then
    printDebugMessage mdVariables.NAME_PREFERENCES_FILE + " does exists. Read readPreferencesFromFile"
    logToDebug "Folders Preferences YES"
    mdVariables.prefExists = True
    mdFileSystem.readPreferencesFromFile mdVariables.NAME_PREFERENCES_FILE
Else
    printDebugMessage mdVariables.NAME_PREFERENCES_FILE + " does exists. Read loadDefaultFolders"
    mdVariables.prefExists = False
    logToDebug "File " & mdVariables.NAME_PREFERENCES_FILE & " doesn't exist. Prepare Slow Sync"
    mdFileSystem.loadDefaultFolders
End If
printDebugMessage "Exit loadFoldersProperties method"
End Sub


' Check if forced slow-sync has been selected for some source.
' (if slow-sync selected, current sync mode settings are ignored)
' In case of slow-sync:
'    1. clean up directories and files
'    2. reset the "last anchor" value (last = 0)
'    3. set sync value = "slow" (backup existing value, will be restored after sync process)
Public Sub checkForcedSlowSync()
    
    printDebugMessage "Enter checkForcedSlowSync method"

    Dim i As Integer
    Dim ret As Integer
    Dim value As String
    Dim syncSlow As String
    Dim anchorResetted As String
    
    anchorResetted = "0"
    syncSlow = "slow"

    syncCalendarsModeBackup = ""
    syncContactsModeBackup = ""
    syncTasksModeBackup = ""
    syncNotesModeBackup = ""

    mdLoad.readAllFolders

    On Error GoTo checkSlowSync_Err
    
    If frmSlowSync.slowSyncForced = False Then
        GoTo checkSlowSync_Exit
    End If
    
    ' Calendars
    ' -----------------------------------------------
    If frmSlowSync.forceCalendarsSlowSync = True Then
        For i = 1 To UBound(mdVariables.calendarFolders)
            'if no, delete the old selected folder if exists
            If Dir(mdVariables.calendarFolders(i).EntryID, vbDirectory) <> "" Then
                ChDir mdVariables.calendarFolders(i).EntryID
                Kill "*.*"
                ChDir ".."
                RmDir mdVariables.calendarFolders(i).EntryID 'delete the relative folder if exsists
            End If
        Next i
        
        mdMMVariables.deleteDirectory DIR_ALL_ITEM_CALENDARS
        mdMMVariables.deleteDirectory DIR_NEW_ITEM_CALENDARS
        mdMMVariables.deleteDirectory DIR_MOD_ITEM_CALENDARS
        
        ' reset last anchor
        ret = setRegSourceProperty(SYNCAPPOINTMENTS, PROPERTY_SOURCE_LAST_ANCHOR, anchorResetted)
        If ret <> 0 Then
            GoTo Error_access_config
        End If
    
        ' Backup the sync value and set it = "slow"
        value = Space(DIM_VALUE)
        ret = getRegSourceProperty(SYNCAPPOINTMENTS, PROPERTY_SOURCE_SYNC, value, DIM_VALUE)
        If ret <> 0 Then
            GoTo Error_access_config
        End If
        syncCalendarsModeBackup = Trim(value)
        
        ret = setRegSourceProperty(SYNCAPPOINTMENTS, PROPERTY_SOURCE_SYNC, syncSlow)
        If ret <> 0 Then
            GoTo Error_access_config
        End If
        
    End If
    
    ' Contacts
    ' -----------------------------------------------
    If frmSlowSync.forceContactsSlowSync = True Then
       For i = 1 To UBound(mdVariables.contactsFolders)
            
            If Dir(mdVariables.contactsFolders(i).EntryID, vbDirectory) <> "" Then
                ChDir mdVariables.contactsFolders(i).EntryID
                Kill "*.*"
                ChDir ".."
                RmDir mdVariables.contactsFolders(i).EntryID 'delete the relative folder if exsists
            End If
        Next i
        
        If mdFileSystem.doesFileExist(mdVariables.NAME_PREFERENCES_FILE) Then
            Kill mdVariables.NAME_PREFERENCES_FILE
        End If
        
        mdMMVariables.deleteDirectory DIR_ALL_ITEM_CONTACTS
        mdMMVariables.deleteDirectory DIR_NEW_ITEM_CONTACTS
        mdMMVariables.deleteDirectory DIR_MOD_ITEM_CONTACTS
        
        ' reset last anchor
        ret = setRegSourceProperty(SYNCCONTACTS, PROPERTY_SOURCE_LAST_ANCHOR, anchorResetted)
        If ret <> 0 Then
            GoTo Error_access_config
        End If
        
        ' Backup the sync value and set it = "slow"
        value = Space(DIM_VALUE)
        ret = getRegSourceProperty(SYNCCONTACTS, PROPERTY_SOURCE_SYNC, value, DIM_VALUE)
        If ret <> 0 Then
            GoTo Error_access_config
        End If
        syncContactsModeBackup = Trim(value)
        
        ret = setRegSourceProperty(SYNCCONTACTS, PROPERTY_SOURCE_SYNC, syncSlow)
        If ret <> 0 Then
            GoTo Error_access_config
        End If
        
    End If

    ' Tasks
    ' -----------------------------------------------
    If frmSlowSync.forceTasksSlowSync = True Then
        For i = 1 To UBound(mdVariables.tasksFolders)
            If Dir(mdVariables.tasksFolders(i).EntryID, vbDirectory) <> "" Then
                ChDir mdVariables.tasksFolders(i).EntryID
                Kill "*.*"
                ChDir ".."
                RmDir mdVariables.tasksFolders(i).EntryID 'delete the relative folder if exsists
            End If
        Next i
        
        mdMMVariables.deleteDirectory DIR_ALL_ITEM_TASKS
        mdMMVariables.deleteDirectory DIR_NEW_ITEM_TASKS
        mdMMVariables.deleteDirectory DIR_MOD_ITEM_TASKS
        
        ' reset last anchor
        ret = setRegSourceProperty(SYNCTASKS, PROPERTY_SOURCE_LAST_ANCHOR, anchorResetted)
        If ret <> 0 Then
            GoTo Error_access_config
        End If
        
        ' Backup the sync value and set it = "slow"
        value = Space(DIM_VALUE)
        ret = getRegSourceProperty(SYNCTASKS, PROPERTY_SOURCE_SYNC, value, DIM_VALUE)
        If ret <> 0 Then
            GoTo Error_access_config
        End If
        syncTasksModeBackup = Trim(value)
        
        ret = setRegSourceProperty(SYNCTASKS, PROPERTY_SOURCE_SYNC, syncSlow)
        If ret <> 0 Then
            GoTo Error_access_config
        End If
      
    End If

    ' Notes
    ' -----------------------------------------------
    If frmSlowSync.forceNotesSlowSync = True Then
        For i = 1 To UBound(mdVariables.notesFolders)
            If Dir(mdVariables.notesFolders(i).EntryID, vbDirectory) <> "" Then
                ChDir mdVariables.notesFolders(i).EntryID
                Kill "*.*"
                ChDir ".."
                RmDir mdVariables.notesFolders(i).EntryID 'delete the relative folder if exsists
            End If
        Next i
        
        mdMMVariables.deleteDirectory DIR_ALL_ITEM_NOTES
        mdMMVariables.deleteDirectory DIR_NEW_ITEM_NOTES
        mdMMVariables.deleteDirectory DIR_MOD_ITEM_NOTES
        
        ' reset last anchor
        ret = setRegSourceProperty(SYNCNOTES, PROPERTY_SOURCE_LAST_ANCHOR, anchorResetted)
        If ret <> 0 Then
            GoTo Error_access_config
        End If
        
        ' Backup the sync value and set it = "slow"
        value = Space(DIM_VALUE)
        ret = getRegSourceProperty(SYNCNOTES, PROPERTY_SOURCE_SYNC, value, DIM_VALUE)
        If ret <> 0 Then
            GoTo Error_access_config
        End If
        syncNotesModeBackup = Trim(value)
        
        ret = setRegSourceProperty(SYNCNOTES, PROPERTY_SOURCE_SYNC, syncSlow)
        If ret <> 0 Then
            GoTo Error_access_config
        End If
     
    End If
        
checkSlowSync_Exit:
    printDebugMessage "Exit checkForcedSlowSync method"
    Exit Sub

checkSlowSync_Err:

    Dim actionToDo As Integer
    
    actionToDo = mdErrors.fixErrors(Err.number)
    Select Case actionToDo
    Case 0
        GoTo checkSlowSync_Exit
    Case 1
        Resume
    Case 2
        Resume Next
    End Select
    
    Exit Sub
    
Error_access_config:
    MsgBox mdMMVariables.CONF_NOT_SAVE_SUCCESFULLY
    
End Sub

' Restore registry keys saved in case of forced slow-sync
' (we don't want to leave the "slow" value for next sync...)
Public Sub restoreSlowSyncBackup()
    
    Dim ret As Integer
    printDebugMessage "Enter restoreSlowSyncBackup method"
    
    If syncCalendarsModeBackup <> "" Then
        ret = setRegSourceProperty(SYNCAPPOINTMENTS, PROPERTY_SOURCE_SYNC, syncCalendarsModeBackup)
        If ret <> 0 Then
            GoTo Error_saving_config
        End If
    End If
    If syncContactsModeBackup <> "" Then
        ret = setRegSourceProperty(SYNCCONTACTS, PROPERTY_SOURCE_SYNC, syncContactsModeBackup)
        If ret <> 0 Then
            GoTo Error_saving_config
        End If
    End If
    If syncTasksModeBackup <> "" Then
        ret = setRegSourceProperty(SYNCTASKS, PROPERTY_SOURCE_SYNC, syncTasksModeBackup)
        If ret <> 0 Then
            GoTo Error_saving_config
        End If
    End If
    If syncNotesModeBackup <> "" Then
        ret = setRegSourceProperty(SYNCNOTES, PROPERTY_SOURCE_SYNC, syncNotesModeBackup)
        If ret <> 0 Then
            GoTo Error_saving_config
        End If
    End If
    
    ' reset variables
    syncCalendarsModeBackup = ""
    syncContactsModeBackup = ""
    syncTasksModeBackup = ""
    syncNotesModeBackup = ""
    
    frmSlowSync.discardValues
    
    
    printDebugMessage "Exit restoreSlowSyncBackup method"
    Exit Sub
    
Error_saving_config:
    MsgBox mdMMVariables.CONF_NOT_SAVE_SUCCESFULLY

End Sub


Public Function loadConfig()
    
    frmMMSetting.load
    
    Dim ret As Integer
    ret = 0
    If frmMMSetting.usernameText.text = "" Or frmMMSetting.passwordText.text = "" Then
        ret = MsgBox("Username and/or password are not set. Would you set it now?", vbOKCancel)
    End If
    
    loadConfig = ret
    
End Function


' Just to manage unexpected and uncatched errors that may occurr...
Public Sub synchronize()

On Error GoTo synchronize_Err

    startSync
    
    Exit Sub


synchronize_Err:

    Dim errMsg As String
    errMsg = "Error #" & Err.number & " - " & Err.Description
    printLog errMsg, ERROR_LEVEL

    Dim actionToDo As Integer
    actionToDo = mdErrors.fixErrors(Err.number)
    
    Select Case actionToDo
    Case 0
        StatusBar1.SimpleText = mdMMVariables.WAITLABEL_CAPTION_COMPLETED_WITH_ERROR
        Exit Sub
    Case 1
        Resume
    Case 2
        Resume Next
    ' This is an uncatched overflow error:
    Case 6
        StatusBar1.SimpleText = mdMMVariables.WAITLABEL_CAPTION_COMPLETED_WITH_ERROR
        Resume Next
    End Select

End Sub


Public Sub startSync()

Dim productName As String
Dim ret As Integer
productName = mdMMVariables.ABOUT_PRODUCT_NAME + mdMMVariables.getVersion

'to open log file in dll (log is resetted here)
ret = openLog(mdMMVariables.AppPath(), productName)

printLog "Starting synchronization...", INFO_LEVEL

'initialize default max date
mdActions.populateDefaultDate
printDebugMessage "Enter synchronize method"
mdWinVersion.GetOSVersion
'variable that indicate the error type. If the error is critical (as "error connecting to the server") the sync stops
isBlocking = False

ret = loadConfig

'1 ok, 2 cancel
If ret = 1 Then
   frmMMSetting.Show 1
    Exit Sub
ElseIf ret = 2 Then
    Exit Sub
End If

Dim path As String
path = mdMMVariables.AppPath()
'ChDir (path)
ChDir (mdMMVariables.AppPath())

printDebugMessage "Current app dir: " + CurDir

Dim outlookArleadyRunning As Boolean
outlookArleadyRunning = IsOutlookProcessRunning
keyValue = getAddinValue

If outlookArleadyRunning = True Or keyValue = 2 Then
    'ok nothing to do
Else
    'check if the LoadBehavior not exists (0 is returned) or its value is set to 2 (add-in not loaded)
    'then it's possible to continue
    'if checked to 3 switch to 2 and continue
    'at the end resume the LoadBehavior to 3
    'LoadBehaviour is the key inserted by OutlookAddin to create a button in MS Outlook
    'If the Addin is arleady loaded is not possible create a reference to outlook from here
   
   If keyValue = 3 Then
    setAddinValue (2)
   End If
   
End If


StatusBar1.SimpleText = mdMMVariables.WAITLABEL_CAPTION_W
logoSync.Picture = LoadPicture(App.path & "\" & DIR_IMAGES & "\" & mdMMVariables.ARROWS_BMP)
logoSync.Enabled = False
exitButton.Caption = mdMMVariables.EXIT_BUTTON_WAIT
exitButton.Enabled = False
Wait 1

If mdMMVariables.isOutlookInitialized = False Then
   loadOutlook
   mdMMVariables.isOutlookInitialized = True
End If


' SLOW-SYNC CHECK: if slow-sync, delete appropriate directories
' -----------------
checkForcedSlowSync

loadFoldersProperties

If keyValue = 3 Then
  setAddinValue (3)
End If

'try daylight set 0...
mdMMVariables.dayLight = 0 'getDayLight

'modified MM to create a string to share with dll

Dim returnXml As String
Dim insertXml As String

Dim folderType As String
Dim syncModeContacts As String
Dim syncModeCalendar As String
Dim syncModeTask As String
Dim syncModeNote As String
Dim returnedErrorFromServer As Boolean
returnedErrorFromServer = False

Dim result As Integer
Dim countInsertedItems As Integer

Dim retSync As Integer
Dim retAddr As Integer

'initialize droppedItems variable.
'it will contains the number of the items dropped because there are in wrong format.
' used for the item that should be added
mdMMVariables.droppedItems = 0


'Before sync: we need to set the addresses of CALLBACK functions for API C++
'(these functions are called inside WindowsSyncSource methods)
retAddr = setCBFunctionsAddresses(AddressOf getStringAllItemsInFolderOnFileSystem, _
                                  AddressOf getStringAllItemsInFolderContactsOnFileSystem, _
                                  AddressOf getStringNewItemsInFolderOnFileSystem, _
                                  AddressOf getStringNewItemsInFolderContactsOnFileSystem, _
                                  AddressOf getStringModItemsInFolderOnFileSystem, _
                                  AddressOf getStringModItemsInFolderContactsOnFileSystem, _
                                  AddressOf getStringDelItemsInFolder, _
                                  AddressOf getStringDelItemsInFolderContacts, _
                                  AddressOf getStringAllItemsKeyInFolder, _
                                  AddressOf getStringAllItemsKeyInFolderContacts, _
                                  AddressOf mdMMServer2Client.addItem, _
                                  AddressOf mdMMServer2Client.addItemContacts, _
                                  AddressOf mdMMServer2Client.updateItem, _
                                  AddressOf mdMMServer2Client.updateItemContacts, _
                                  AddressOf mdMMServer2Client.deleteItem, _
                                  AddressOf prepareSyncFiles)


'Note:
'------
'Now sync process is menaged with 4 indipendent call to "synchronization" function on DLL,
' so different sync sessions are created for CONTACTS, APPOINTMENTS, TASKS and NOTES.


'************************************** SYNC CONTACTS *****************************************
'**********************************************************************************************
folderType = "" & olFolderContacts
syncModeContacts = Space(16)
Dim sourceContactsToSync As Boolean

'Get info about which source to sync (read from win register)
result = getRegSourceProperty(SYNC_CONTACTS, PROPERTY_SOURCE_SYNC, syncModeContacts, 16)

' Check if we need to synchronize this source
sourceContactsToSync = False
If (frmSlowSync.slowSyncForced) Then
    If frmSlowSync.forceContactsSlowSync Then                  ' 1) Slow-sync forced
        sourceContactsToSync = True
    End If
Else
    If Trim(syncModeContacts) <> mdMMVariables.NONE Then        ' 2) Normal sync
        sourceContactsToSync = True
    End If
End If

If (sourceContactsToSync) Then
    printLog "**********  CONTACTS SYNC  ************", INFO_LEVEL
    ChangeStatusBar WAIT_SYNCING_CON

    
    'Set public variables as input for callback functions.
    mdVariables.currentObjFolder = olFolderContacts
    mdVariables.currentFolderType = mdVariables.FOLDER_TYPE_CON
    mdVariables.currentFolders = mdVariables.contactsFolders
    
    '-> moved in winmainclientdll:beginSync() with a callback
    'mdSyncAgent.prepareSyncFiles
    
    countInsertedContacts = 0
    countDeletedContacts = 0
    countUpdatedContacts = 0
    
    '---------------------------------------------------------
    'The whole synchronization process is menaged by this call
    retSync = synchronization(folderType, path)
    '---------------------------------------------------------
    
    ChDir (mdMMVariables.AppPath())
    
    'All right
    If (retSync = 0) Then
        printLog "Contacts sync succesfully completed", INFO_LEVEL
        endOfFolderSyncContacts mdVariables.contactsFolders, mdVariables.FOLDER_TYPE_CON, True
    
    'Error in sync
    Else
        printLog "Contacts sync completed with errors", INFO_LEVEL
        returnedErrorFromServer = True
    End If


    'Modification for contact on filesystem (2.3)
    'ChDir (path)
    ChDir (mdMMVariables.AppPath())
    mdMMVariables.deleteDirectory DIR_ALL_ITEM_CONTACTS
    mdMMVariables.deleteDirectory DIR_MOD_ITEM_CONTACTS
    mdMMVariables.deleteDirectory DIR_NEW_ITEM_CONTACTS
    
    If mdFileSystem.doesFileExist(SERVER_ITEMS) Then
        Kill SERVER_ITEMS
    End If
                    
    consolidatePreferences mdVariables.contactsFolders
End If
'************************************ end sync contacts ***************************************



'************************************** SYNC CALENDAR *****************************************
'**********************************************************************************************
folderType = "" & olFolderCalendar
syncModeCalendar = Space(16)
Dim sourceCalendarsToSync As Boolean

'Get info about which source to sync (read from win register)
result = getRegSourceProperty(SYNC_APPOINTMENTS, PROPERTY_SOURCE_SYNC, syncModeCalendar, 16)

' Check if we need to synchronize this source
sourceCalendarsToSync = False
If (frmSlowSync.slowSyncForced) Then
    If frmSlowSync.forceCalendarsSlowSync Then                  ' 1) Slow-sync forced
        sourceCalendarsToSync = True
    End If
Else
    If Trim(syncModeCalendar) <> mdMMVariables.NONE Then        ' 2) Normal sync
        sourceCalendarsToSync = True
    End If
End If

If (sourceCalendarsToSync And isBlocking = False) Then
    printLog "**********  CALENDAR SYNC  ************", INFO_LEVEL
    ChangeStatusBar WAIT_SYNCING_CAL
    
    'Set public variables as input for callback functions.
    mdVariables.currentObjFolder = olFolderCalendar
    mdVariables.currentFolderType = mdVariables.FOLDER_TYPE_CAL
    mdVariables.currentFolders = mdVariables.calendarFolders
    
    '-> moved in winmainclientdll:beginSync() with a callback
    'mdSyncAgent.prepareSyncFiles
    
    countInsertedAppointments = 0
    countDeletedAppointments = 0
    countUpdatedAppointments = 0
    
    '---------------------------------------------------------
    'The whole synchronization process is menaged by this call
    retSync = synchronization(folderType, path)
    '---------------------------------------------------------
         
    'All right
    If (retSync = 0) Then
        printLog "Calendar sync succesfully completed", INFO_LEVEL
        endOfFolderSync olFolderCalendar, mdVariables.FOLDER_TYPE_CAL, True
    
    'Error in sync
    Else
        printLog "Calendar sync completed with errors", INFO_LEVEL
        returnedErrorFromServer = True
    End If
    
    'Modification on filesystem (2.3)
    mdMMVariables.deleteDirectory DIR_ALL_ITEM_CALENDARS
    mdMMVariables.deleteDirectory DIR_NEW_ITEM_CALENDARS
    mdMMVariables.deleteDirectory DIR_MOD_ITEM_CALENDARS
    
    If mdFileSystem.doesFileExist(SERVER_ITEMS) Then
        Kill SERVER_ITEMS
    End If
    
    consolidatePreferences mdVariables.calendarFolders
End If
'************************************ end sync calendar ***************************************



'*************************************** SYNC TASKS *******************************************
'**********************************************************************************************
folderType = "" & olFolderTasks
syncModeTask = Space(16)
Dim sourceTasksToSync As Boolean

'Get info about which source to sync (read from win register)
result = getRegSourceProperty(SYNC_TASKS, PROPERTY_SOURCE_SYNC, syncModeTask, 16)

' Check if we need to synchronize this source
sourceTasksToSync = False
If (frmSlowSync.slowSyncForced) Then
    If frmSlowSync.forceTasksSlowSync Then                  ' 1) Slow-sync forced
        sourceTasksToSync = True
    End If
Else
    If Trim(syncModeTask) <> mdMMVariables.NONE Then        ' 2) Normal sync
        sourceTasksToSync = True
    End If
End If

If (sourceTasksToSync And isBlocking = False) Then
    printLog "**********  TASKS SYNC  ************", INFO_LEVEL
    ChangeStatusBar WAIT_SYNCING_TASK
    
    'Set public variables as input for callback functions.
    mdVariables.currentObjFolder = olFolderTasks
    mdVariables.currentFolderType = mdVariables.FOLDER_TYPE_TASK
    mdVariables.currentFolders = mdVariables.tasksFolders
    
    '-> moved in winmainclientdll:beginSync() with a callback
    'mdSyncAgent.prepareSyncFiles
    
    countInsertedTasks = 0
    countDeletedTasks = 0
    countUpdatedTasks = 0
    
    '----------------------------------------------------------
    'The whole synchronization process is menaged by this call!
    retSync = synchronization(folderType, path)
    '----------------------------------------------------------
               
    'All right
    If (retSync = 0) Then
        printLog "Tasks sync succesfully completed", INFO_LEVEL
        endOfFolderSync olFolderTasks, mdVariables.FOLDER_TYPE_TASK, True
    
    'Error in sync
    Else
        printLog "Tasks sync completed with errors", INFO_LEVEL
        returnedErrorFromServer = True
    End If
        
    'modification on filesystem (2.3)
    mdMMVariables.deleteDirectory DIR_ALL_ITEM_TASKS
    mdMMVariables.deleteDirectory DIR_NEW_ITEM_TASKS
    mdMMVariables.deleteDirectory DIR_MOD_ITEM_TASKS
    
    If mdFileSystem.doesFileExist(SERVER_ITEMS) Then
        Kill SERVER_ITEMS
    End If
    
    consolidatePreferences mdVariables.tasksFolders
End If
'************************************* end sync tasks *****************************************



'*************************************** SYNC NOTES *******************************************
'**********************************************************************************************
folderType = "" & olFolderNotes
syncModeNote = Space(16)
Dim sourceNotesToSync As Boolean

'Get info about which source to sync (read from win register)
result = getRegSourceProperty(SYNC_NOTES, PROPERTY_SOURCE_SYNC, syncModeNote, 16)

' Check if we need to synchronize this source
sourceNotesToSync = False
If (frmSlowSync.slowSyncForced) Then
    If frmSlowSync.forceNotesSlowSync Then                  ' 1) Slow-sync forced
        sourceNotesToSync = True
    End If
Else
    If Trim(syncModeNote) <> mdMMVariables.NONE Then        ' 2) Normal sync
        sourceNotesToSync = True
    End If
End If

If (sourceNotesToSync And isBlocking = False) Then
    printLog "**********  NOTES SYNC  ************", INFO_LEVEL
    ChangeStatusBar WAIT_SYNCING_NOTE
    
    'Set public variables as input for callback functions.
    mdVariables.currentObjFolder = olFolderNotes
    mdVariables.currentFolderType = mdVariables.FOLDER_TYPE_NOTE
    mdVariables.currentFolders = mdVariables.notesFolders
    
    '-> moved in winmainclientdll:beginSync() with a callback
    'mdSyncAgent.prepareSyncFiles
    
    countInsertedNotes = 0
    countDeletedNotes = 0
    countUpdatedNotes = 0
    
    '----------------------------------------------------------
    'The whole synchronization process is menaged by this call!
    retSync = synchronization(folderType, path)
    '----------------------------------------------------------

    'All right
    If (retSync = 0) Then
        printLog "Notes sync succesfully completed", INFO_LEVEL
        endOfFolderSync olFolderNotes, mdVariables.FOLDER_TYPE_NOTE, True
    
    'Error in sync
    Else
        printLog "Notes sync completed with errors", INFO_LEVEL
        returnedErrorFromServer = True
    End If
    
    'modification on filesystem (2.3)
    mdMMVariables.deleteDirectory DIR_ALL_ITEM_NOTES
    mdMMVariables.deleteDirectory DIR_NEW_ITEM_NOTES
    mdMMVariables.deleteDirectory DIR_MOD_ITEM_NOTES
    
    If mdFileSystem.doesFileExist(SERVER_ITEMS) Then
        Kill SERVER_ITEMS
    End If
    
    consolidatePreferences mdVariables.notesFolders
End If
'************************************* end sync notes *****************************************


If sourceContactsToSync = False And sourceCalendarsToSync = False _
   And sourceTasksToSync = False And sourceNotesToSync = False Then
    
    StatusBar1.SimpleText = mdMMVariables.WAITLABEL_NO_SOURCE_TO_SYNC
    printLog mdMMVariables.WAITLABEL_NO_SOURCE_TO_SYNC, INFO_LEVEL
    printLog "Sync ended", INFO_LEVEL

ElseIf mdMMVariables.droppedItems > 0 Then
    StatusBar1.SimpleText = mdMMVariables.WAITLABEL_CAPTION_DROPPED
    
ElseIf isBlocking = True Then
    'leave the error

ElseIf returnedErrorFromServer = True Then
    StatusBar1.SimpleText = mdMMVariables.WAITLABEL_CAPTION_COMPLETED_WITH_ERROR

Else
    StatusBar1.SimpleText = mdMMVariables.WAITLABEL_CAPTION_END
End If

logoSync.Picture = LoadPicture(App.path & "\" & DIR_IMAGES & "\" & mdMMVariables.ARROWS_BMP)
logoSync.Enabled = True
exitButton.Caption = mdMMVariables.EXIT_BUTTON
exitButton.Enabled = True

' Restore registry keys in case of (forced) slow-sync
restoreSlowSyncBackup

'Logoff Outlook and clean up shared objects
exitOutlook

Close

End Sub
Function returnErrorLabel(ByVal xml As String)

    Dim initCode As Long
    Dim endCode As Long
    Dim errorCode As String
    Dim originalErrorMessage As String
    
    errorCode = ""
    originalErrorMessage = ""
    
    initCode = InStr(xml, "error code: ")
    endCode = InStr(xml, "error message:")
    If initCode <> 0 Then
        initCode = initCode + Len("error code: ")
        If endCode <> 0 Then
            errorCode = Mid(xml, initCode, endCode - initCode - 1)
            
        End If
        
    End If
    
    'to retrieve the original native api message
    initCode = InStr(xml, "error message:")
    If initCode <> 0 Then
        initCode = initCode + Len("error message: ")
        originalErrorMessage = Mid(xml, initCode)
    End If
    
    Select Case errorCode
        Case ERR_READING_CONTENT
            printLog mdMMVariables.MSG_ERR_READING_CONTENT, INFO_LEVEL
            returnErrorLabel = mdMMVariables.MSG_ERR_READING_CONTENT
            isBlocking = True
         Case ERR_HTTP
            printLog mdMMVariables.MSG_ERR_ERR_HTTP, INFO_LEVEL
            returnErrorLabel = mdMMVariables.MSG_ERR_ERR_HTTP
            isBlocking = True
        Case ERR_PROTOCOL_ERROR
            printLog mdMMVariables.MSG_ERR_PROTOCOL_ERROR, INFO_LEVEL
            returnErrorLabel = mdMMVariables.MSG_ERR_PROTOCOL_ERROR
            isBlocking = True
        Case ERR_AUTH_REQUIRED
            printLog mdMMVariables.MSG_ERR_AUTH_REQUIRED, INFO_LEVEL
            returnErrorLabel = mdMMVariables.MSG_ERR_AUTH_REQUIRED
            isBlocking = True
        Case ERR_NOT_FOUND
            printLog originalErrorMessage + " Please check Synchronization Settings -> Remote Settings name", INFO_LEVEL
            returnErrorLabel = originalErrorMessage
            isBlocking = False
        Case ERR_CONNECT
            printLog mdMMVariables.MSG_ERR_CONNECT, INFO_LEVEL
            returnErrorLabel = mdMMVariables.MSG_ERR_CONNECT
            isBlocking = True
        Case ERR_RESP_URI_DIFFERS_FROM_URL
            printLog originalErrorMessage, INFO_LEVEL
            returnErrorLabel = originalErrorMessage
            isBlocking = True
        Case ERR_GENERIC_FAULT
            printLog originalErrorMessage, INFO_LEVEL
            returnErrorLabel = mdMMVariables.MSG_ERR_GENERIC
            isBlocking = True
        Case Else
            printLog mdMMVariables.MSG_ERR_GENERIC, INFO_LEVEL
            returnErrorLabel = mdMMVariables.MSG_ERR_GENERIC  'xml
            isBlocking = True
    End Select
    

End Function

Private Sub logControl_Click()
    Dim path As String
    path = mdMMVariables.AppPath()
    path = path + "synclog.txt"
    If mdFileSystem.doesFileExist(path) Then
        Shell "Notepad " & path, vbNormalFocus
    Else
        Shell "Notepad ", vbNormalFocus
    End If
End Sub

Private Sub slowSyncControl_Click(Index As Integer)
    frmSlowSync.Show 1
End Sub

Private Sub syncControl_Click(Index As Integer)
    synchronize
End Sub

Private Sub syncSchedulerSettings_Click(Index As Integer)
    frmScheduler.Show 1
End Sub


Private Sub syncSettingsControl_Click(Index As Integer)
    frmMMSetting.Show 1
End Sub

Private Sub syncSourcesControl_Click(Index As Integer)
    frmMMSettingSources.Show 1
    
End Sub


Private Sub Form_Unload(Cancel As Integer)
mdUnload.closeProgram
End Sub



