VERSION 5.00
Begin VB.Form frmProxy 
   BackColor       =   &H80000005&
   Caption         =   "Proxy Settings"
   ClientHeight    =   2925
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4485
   Icon            =   "frmProxy.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   2925
   ScaleWidth      =   4485
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton saveCmd 
      BackColor       =   &H00FFFFFF&
      Caption         =   "OK"
      Height          =   372
      Left            =   1440
      MaskColor       =   &H00FF8080&
      TabIndex        =   6
      Top             =   2400
      Width           =   1332
   End
   Begin VB.CommandButton cancelCmd 
      BackColor       =   &H00FFFFFF&
      Caption         =   "Cancel"
      Height          =   372
      Left            =   3000
      MaskColor       =   &H00FF8080&
      TabIndex        =   5
      Top             =   2400
      Width           =   1332
   End
   Begin VB.Frame Frame1 
      BackColor       =   &H00FFFFFF&
      Caption         =   "Proxy Settings "
      Height          =   1935
      Left            =   120
      TabIndex        =   0
      Top             =   240
      Width           =   4215
      Begin VB.CheckBox proxyCheck 
         BackColor       =   &H80000009&
         Caption         =   "Save Proxy Username / Password"
         Height          =   495
         Left            =   240
         TabIndex        =   7
         Top             =   360
         Width           =   3135
      End
      Begin VB.TextBox passwordText 
         BackColor       =   &H00FFFFFF&
         Height          =   288
         IMEMode         =   3  'DISABLE
         Left            =   1200
         PasswordChar    =   "*"
         TabIndex        =   4
         Top             =   1440
         Width           =   2775
      End
      Begin VB.TextBox usernameText 
         BackColor       =   &H00FFFFFF&
         Height          =   288
         Left            =   1200
         TabIndex        =   1
         Top             =   960
         Width           =   2775
      End
      Begin VB.Label passwordLabel 
         BackColor       =   &H00FFFFFF&
         Caption         =   "Password:"
         Height          =   255
         Left            =   240
         TabIndex        =   3
         Top             =   1440
         Width           =   1335
      End
      Begin VB.Label usernameLabel 
         BackColor       =   &H00FFFFFF&
         Caption         =   "Username:"
         Height          =   375
         Left            =   240
         TabIndex        =   2
         Top             =   960
         Width           =   1215
      End
   End
End
Attribute VB_Name = "frmProxy"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub cancelCmd_Click()
    Unload Me
End Sub

Private Sub Form_Load()

    LoadSettings

    'Center the form in the screen
    Me.Move (Screen.Width - Me.Width) / 2, (Screen.Height - Me.Height) / 2
    
End Sub


Private Sub proxyCheck_Click()

    If proxyCheck.value = 1 Then
        usernameText.Enabled = True
        passwordText.Enabled = True
        usernameLabel.Enabled = True
        passwordLabel.Enabled = True
        'usernameText.SetFocus
    Else
        usernameText.Enabled = False
        passwordText.Enabled = False
        usernameLabel.Enabled = False
        passwordLabel.Enabled = False
    End If
        
End Sub


Private Sub saveCmd_Click()
    SaveSettings
    Unload Me
End Sub


' Load proxy settings from windows registry
Private Sub LoadSettings()

    Dim useProxy As String
    Dim username As String
    Dim password As String
    
    useProxy = Space(DIM_VALUE)
    username = Space(DIM_VALUE)
    password = Space(DIM_VALUE)
    
    getRegConfigProperty SPDM_USE_PROXY, useProxy, DIM_VALUE
    getRegConfigProperty SPDM_PROXY_USERNAME, username, DIM_VALUE
    getRegConfigProperty SPDM_PROXY_PASSWORD, password, DIM_VALUE
     
    usernameText.text = Trim(username)
    passwordText.text = Trim(password)

    If Trim(useProxy) = USE_PROXY_TRUE Then
        proxyCheck.value = 1
        usernameText.Enabled = True
        passwordText.Enabled = True
        usernameLabel.Enabled = True
        passwordLabel.Enabled = True
    Else
        proxyCheck.value = 0
        usernameText.Enabled = False
        passwordText.Enabled = False
        usernameLabel.Enabled = False
        passwordLabel.Enabled = False
    End If

End Sub


' Save proxy settings into windows registry
Private Sub SaveSettings()
    
    ' useProxy
    Dim useProxy As String
    If proxyCheck.value = 1 Then
        useProxy = USE_PROXY_TRUE
    Else
        useProxy = USE_PROXY_FALSE
    End If
    
    ret = setRegConfigProperty(SPDM_USE_PROXY, useProxy)
    If ret <> 0 Then
        GoTo Error_saving_config
    End If
    
    
    ' username / password
    If (proxyCheck.value = 1) Then
        Dim username As String
        Dim password As String
        username = usernameText.text
        password = passwordText.text
    
        ret = setRegConfigProperty(SPDM_PROXY_USERNAME, username)
        If ret <> 0 Then
            GoTo Error_saving_config
        End If
        
        ret = setRegConfigProperty(SPDM_PROXY_PASSWORD, password)
        If ret <> 0 Then
            GoTo Error_saving_config
        End If
    End If
    
    Exit Sub

Error_saving_config:
    MsgBox CONF_NOT_SAVE_SUCCESFULLY

End Sub

